#include <ctime>
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <algorithm>
using namespace std;

//#define HOME

const int MAXN = 128;

int dx[] = { -1 , 0 , 0 , 1 };
int dy[] = { 0 , -1 , 1 , 0 };

struct Rotation {
    int x , y , z;
    
    Rotation () {}
    Rotation ( int _x , int _y , int _z ) {
        x = _x; y = _y; z = _z;
    }
};

int n , m , p , c;
int a[MAXN][MAXN];
int used[MAXN][MAXN];
int b[MAXN];

vector < Rotation > res;

void read() {
    int i , j;
    
    scanf ( "%d%d%d%d" , &n , &m , &p , &c );
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            scanf ( "%d" , &a[i][j] );
}

inline int getRand ( int l , int r ) {
    return l + rand() % (r - l + 1);
}

int dfs ( int x , int y ) {
    used[x][y] = 1;
    int ans = 1;
    int q , w;
    int i;

    for (i = 0; i < 4; i++) {
        q = x + dx[i];
        w = y + dy[i];
        
        if ( q >= 0 && w >= 0 && q < n && w < m && !used[q][w] && a[q][w] == a[x][y] )
            ans += dfs ( q , w );
    }
    
    return ans;
}

int eval() {
    int i , j;
    int ans = 0 , x;
    
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            used[i][j] = 0;
            
    for (i = 0; i < n; i++)
        for (j = 0; j < m; j++)
            if ( !used[i][j] ) {
                x = dfs ( i , j );
                
                ans += x * x;
            }
            
    return ans;
}

void Rotate ( int x , int y , int z ) {
//    printf ( " -- %d %d %d\n" , x , y , z );
    int i;
    
    if ( x == 0 ) {
        for (i = 0; i < m; i++)
            b[i] = a[y][(i + z) % m];
            
        for (i = 0; i < m; i++)
            a[y][i] = b[i];
    } else {
        for (i = 0; i < n; i++)
            b[i] = a[(i + z) % n][y];
            
        for (i = 0; i < n; i++)
            a[i][y] = b[i];
    }
}

void solve() {
    double tim = clock();
    int i;
    int x , y , z , x1 , y1 , z1;
    int ans , cur;
    int optimize;
    
    x1 = y1 = z1 = -1;
    
    ans = eval();
    int iter = 0;
    
    for (; (int)res.size() <= p && ((double)clock() - tim) / (double)CLOCKS_PER_SEC < 4.5; ) {
        ++ iter;
      //  printf ( " %d\n" , (int)res.size() );
        x = getRand ( 0 , 1 );
        
        optimize = 0;
        
        if ( n <= 16 && m <= 16 )
            optimize = 1;
        
        if ( x == 0 ) {
            y = getRand ( 0 , n - 1 );
            z = getRand ( 1 , m - 1 );
        } else {
            y = getRand ( 0 , m - 1 );
            z = getRand ( 1 , n - 1 );
        }
        
        if ( optimize ) {
            x1 = x ^ 1;
        
            if ( x1 == 0 ) {
                y1 = getRand ( 0 , n - 1 );
                z1 = getRand ( 1 , m - 1 );
            } else {
                y1 = getRand ( 0 , m - 1 );
                z1 = getRand ( 1 , n - 1 );
            }
        }
        
        Rotate ( x , y , z );
        if ( optimize ) Rotate ( x1 , y1 , z1 );
        
        cur = eval();
        
        if ( cur > ans ) {
            res.push_back ( Rotation ( x , y , z ) );
            if ( optimize ) res.push_back ( Rotation ( x1 , y1 , z1 ) );
            ans = cur;
        } else {
            if ( optimize ) {
                if ( x1 == 0 )
                    z1 = m - z1;
                else
                    z1 = n - z1;
            }
            if ( x == 0 )
                z = m - z;
            else
                z = n - z;
            
            if ( optimize ) Rotate ( x1 , y1 , z1 );    
            Rotate ( x , y , z );
        }
    }   
    
//    printf ( "made %d iterations\n" , iter );
    
    printf ( "%d\n" , (int)res.size() );
 //  return ;
    for (i = 0; i < (int)res.size(); i++)
        printf ( "%c %d %d\n" , res[i].x ? 'U' : 'L' , res[i].y + 1 , res[i].z );
}

int main() {
#ifndef HOME
    freopen ( "recycle.in" , "r" , stdin );
    freopen ( "recycle.out" , "w" , stdout );
#endif

    read();
    solve();
    
    return 0;
}
